django_project/urls.py
from django.conf import settings
from django.urls import path
from django.urls import include
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.conf.urls.static import static

urlpatterns = [
    path("", include("polls.urls")),
    path("admin/", admin.site.urls),
    path("accounts/", include("users.urls")),
    path("accounts/", include("user_profile.urls")),
]

urlpatterns += [
    path(
        "accounts/password_change/",
        auth_views.PasswordChangeView.as_view(template_name="registration/password_change.html"),
        name="password_change",
    ),
    path(
        "accounts/password_change/done/",
        auth_views.PasswordChangeDoneView.as_view(template_name="registration/password_change_done.html"),
        name="password_change_done",
    ),
    path(
        "accounts/login/",
        auth_views.LoginView.as_view(template_name="registration/login.html"),
        name="login",
    ),
    path(
        "accounts/logout/",
        auth_views.LogoutView.as_view(template_name="registration/logout.html"),
        name="logout",
    ),
    path(
        "accounts/password_reset/",
        auth_views.PasswordResetView.as_view(template_name="registration/password_reset.html"),
        name="password_reset",
    ),
    path(
        "accounts/password_reset/done/",
        auth_views.PasswordResetDoneView.as_view(template_name="registration/password_reset_done.html"),
        name="password_reset_done",
    ),
    path(
        "accounts/reset/<uidb64>/<token>/",
        auth_views.PasswordResetConfirmView.as_view(template_name="registration/password_reset_confirm.html"),
        name="password_reset_confirm",
    ),
    path(
        "accounts/reset/done/",
        auth_views.PasswordResetCompleteView.as_view(template_name="registration/password_reset_complete.html"),
        name="password_reset_complete",
    ),
]


urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

polls/urls.py
"""Polls app URL."""

from django.urls import path

from . import views

app_name = "polls"

urlpatterns = [
    path("question/add/", views.CreateQuestionView.as_view(), name="create-question"),
    path("<int:pk>/choice/add/", views.CreateChoiceView.as_view(), name="create-choice"),
    path("", views.QuestionListView.as_view(), name="question-list"),
    path("<int:pk>/", views.QuestionDetailView.as_view(), name="question-detail"),
    path("<int:pk>/edit/", views.UpdateQuestionView.as_view(), name="update-question"),
    path("<int:pk>/delete/", views.DeleteQuestionView.as_view(), name="delete-question"),
    path("<int:pk>/results/", views.ResultsView.as_view(), name="results"),
    path("<int:question_id>/vote/", views.SubmitVote.as_view(), name="vote"),
]

polls/models.py
"""Polls models."""

from datetime import timedelta

from django.db import models
from django.utils.timezone import now

from users.models import CustomUser


class Question(models.Model):
    """Question model class.

    Attributes
    ----------
    author : ForeignKey
        Holds the author of the question.
    answered_by : ManyToManyField
        Holds the users who have answered the question.
    question_text : string
        Holds the text for the question.
    pub_date : datetime
        Holds the date and time of the question.

    """

    author = models.ForeignKey(CustomUser, on_delete=models.CASCADE, null=True, blank=True)
    answered_by = models.ManyToManyField(CustomUser, related_name="question_users")
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField("date published")

    def __str__(self) -> str:
        """Return a string representation of Question."""
        return str(self.question_text)

    def was_published_recently(self):
        """Check if Question was published in last 24 hours.

        Returns
        -------
        bool:
            True, if published in last 24 hours.
            False, otherwise.

        """
        return now() >= self.pub_date >= now() - timedelta(days=1)


class Choice(models.Model):
    """Choice model class.

    Attributes
    ----------
    answered_choice : ManyToManyField
        Holds the users who have answered the question with the choice.
    question : foreign key
        Holds a reference to the Question class object.
    choice_text : string
        Holds a string that represents a choice.

    """

    answered_choice = models.ManyToManyField(CustomUser, related_name="choice_users")
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self) -> str:
        """Return a string representation of Choice."""
        return str(self.choice_text)

polls/views.py
"""Polls app views."""

from django.http import HttpResponseRedirect
from django.urls import reverse
from django.urls import reverse_lazy
from django.views import View
from django.views import generic
from django.shortcuts import render
from django.shortcuts import get_object_or_404
from django.utils.timezone import now
from django.contrib.auth.mixins import LoginRequiredMixin

from user_profile import mixins as user_mixins

from . import mixins
from . import models


class CreateQuestionView(mixins.TeacherRequiredMixin, generic.CreateView):
    """View to create question."""

    model = models.Question
    fields = ["question_text"]
    success_url = reverse_lazy("polls:question-list")
    template_name = "generic_create_update_form.html"
    extra_context = {"title_text": "Add Question", "button_text": "Add"}

    def form_valid(self, form: object) -> object:
        """For valid form submission.

        - Set the published date as the current date and time.
        - Set the author as the current logged in user.

        """
        form.instance.pub_date = now()
        form.instance.author = self.request.user
        return super().form_valid(form)


class UpdateQuestionView(mixins.TeacherAuthorRequiredMixin, generic.UpdateView):
    """View to update question."""

    model = models.Question
    fields = ["question_text", "pub_date"]
    success_url = reverse_lazy("polls:question-list")
    template_name = "generic_create_update_form.html"
    extra_context = {"title_text": "Edit Question", "button_text": "Update"}


class DeleteQuestionView(mixins.TeacherAuthorRequiredMixin, generic.DeleteView):
    """View to delete question."""

    model = models.Question
    success_url = reverse_lazy("polls:question-list")
    template_name = "generic_delete_confirm_form.html"
    extra_context = {"title_text": "Delete Question"}


class QuestionListView(generic.ListView):
    """Question List view of polls app.

    Default `template_name` if not specified is "polls/question_list.html"

    """

    model = models.Question
    queryset = models.Question.objects.order_by("-pub_date")[:5]


class QuestionDetailView(LoginRequiredMixin, generic.DetailView):
    """Detail view of polls app.

    Default `template_name` if not specified is "polls/question_detail.html"

    """

    model = models.Question


class CreateChoiceView(user_mixins.TeacherRequiredMixin, generic.CreateView):
    """View to create choice."""

    model = models.Choice
    fields = ["choice_text"]
    template_name = "generic_create_update_form.html"
    extra_context = {"title_text": "Add Choice", "button_text": "Add"}

    def get_success_url(self) -> object:
        """Overwrite the `success_url` to generate a dynamic URL.

        - Get the `pk` from the URLs to get the `question_id`.
        - Redirect to the question detail view of the question to which choice being added.

        """
        question_id = self.kwargs["pk"]
        return reverse_lazy("polls:question-detail", kwargs={"pk": question_id})

    def form_valid(self, form: object) -> object:
        """If the form data is valid, add current time as `pub_date`.

        - Set the `question` field (ForeignKey) of `Choice` model.
        - Get the `pk` from the URLs to get the `question_id`.

        """
        form.instance.question_id = self.kwargs["pk"]
        return super().form_valid(form)


class ResultsView(LoginRequiredMixin, generic.DetailView):
    """Results view of polls app."""

    model = models.Question
    template_name = "polls/results.html"


class SubmitVote(user_mixins.StudentRequiredMixin, View):
    """Vote View."""

    def post(self, request: object, question_id: int) -> object:
        """Vote counter function.

        - Set the `answered_by` for the `question` and `choice` objects as the current user.
        - Increment the `votes` for the `choice` by one.

        """
        question = get_object_or_404(models.Question, pk=question_id)
        try:
            question.answered_by.add(self.request.user)
            selected_choice = question.choice_set.get(pk=request.POST["choice"])
            selected_choice.answered_choice.add(self.request.user)
            selected_choice.votes += 1
            selected_choice.save()
            question.save()
        except (KeyError, models.Choice.DoesNotExist):
            context = {
                "question": question,
                "error_message": "You didn't select a choice.",
            }
            return render(request, "polls/details.html", context)
        return HttpResponseRedirect(reverse("polls:results", args=(question.id,)))

polls/templates/polls/question_detail.html
{% extends "base_generic.html" %}
{% block title %}
    Question: {{ question.question_text }}
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-6">
            <div class="text-center">
                {% if user.is_authenticated and user.userprofile.is_teacher and question.author == user %}
                    <a class="btn btn-primary"
                       href="{% url 'polls:update-question' question.id %}">
                        <i class="fa-solid fa-edit"></i> Edit
                    </a>
                    <a class="btn btn-danger"
                       href="{% url 'polls:delete-question' question.id %}">
                        <i class="fa-solid fa-trash"></i> Delete
                    </a>
                {% else %}
                    <a class="btn btn-primary disabled"
                       href="{% url 'polls:update-question' question.id %}"
                       role="button"
                       aria-disabled="true">
                        <i class="fa-solid fa-edit"></i> Edit
                    </a>
                    <a class="btn btn-danger disabled"
                       href="{% url 'polls:delete-question' question.id %}"
                       role="button"
                       aria-disabled="true">
                        <i class="fa-solid fa-trash"></i> Delete
                    </a>
                {% endif %}
            </div>
        </div>
    </div>
    <div class="row justify-content-center mb-5">
        <div class="col-md-4"></div>
        <div class="col-md-4 centered">
            <p class="centered text-secondary">
                Author: {{ question.author.get_full_name }}
                {% if question.author == user %}
                    (You)
                {% else %}
                    (Not You)
                {% endif %}
            </p>
            <p class="centered text-secondary">Date published: {{ question.pub_date }}</p>
        </div>
        <div class="col-md-4"></div>
    </div>
    <div class="row justify-content-center">
        <div class="col-md-6">
            {% if error_message %}<div class="alert alert-danger" role="alert">{{ error_message }}</div>{% endif %}
            <form action="{% url 'polls:vote' question.id %}" method="post">
                {% csrf_token %}
                {% for choice in question.choice_set.all %}
                    <div class="row">
                        <div class="col-md-1">
                            <input type="radio"
                                   name="choice"
                                   id="choice{{ forloop.counter }}"
                                   value="{{ choice.id }}" />
                        </div>
                        <div class="col-md-5 mb-1">
                            <label for="choice{{ forloop.counter }}">{{ choice.choice_text }}</label>
                        </div>
                    </div>
                {% endfor %}
                <div class="text-center mb-4">
                    {% if user.is_authenticated and user.userprofile.is_student %}
                        <input class="btn btn-success" type="submit" value="Vote" />
                    {% else %}
                        <input class="btn btn-success" type="submit" value="Vote" disabled />
                    {% endif %}
                </div>
            </form>
        </div>
    </div>
    <div class="row justify-content-center mb-4">
        <div class="col-md-6">
            <div class="text-center">
                {% if user.is_authenticated and user.userprofile.is_teacher and question.author == user %}
                    <a class="btn btn-warning"
                       href="{% url 'polls:create-choice' question.id %}">
                        <i class="fa-solid fa-plus"></i> Add choice
                    </a>
                {% else %}
                    <a class="btn btn-warning disabled"
                       href="{% url 'polls:create-choice' question.id %}"
                       role="button"
                       aria-disabled="true">
                        <i class="fa-solid fa-plus"></i> Add choice
                    </a>
                {% endif %}
                {% if user.is_authenticated and user.userprofile.is_teacher %}
                    <a class="btn btn-warning" href="{% url 'polls:results' question.id %}">
                        <i class="fa-solid fa-poll"></i> View Polling Result
                    </a>
                {% else %}
                    <a class="btn btn-warning disabled"
                       href="{% url 'polls:results' question.id %}"
                       role="button"
                       aria-disabled="true">
                        <i class="fa-solid fa-poll"></i> View Polling Result
                    </a>
                {% endif %}
            </div>
        </div>
    </div>
{% endblock content %}

polls/templates/polls/question_list.html
{% extends "base_generic.html" %}
{% block title %}
    Available Polls
{% endblock title %}
{% block content %}
    <div class="row justify-content-center mb-4">
        <div class="col-md-6">
            {% if object_list %}
                <ol>
                    {% for question in object_list %}
                        <li>
                            <a href="{% url 'polls:question-detail' question.id %}">{{ question.question_text }}</a>
                        </li>
                    {% endfor %}
                </ol>
            {% else %}
                <p>No polls are available.</p>
            {% endif %}
        </div>
    </div>
    <div class="row justify-content-center">
        <div class="col-md-4">
            <div class="text-center">
                {% if user.is_authenticated and user.userprofile.is_teacher %}
                    <a class="btn btn-warning" href="{% url 'polls:create-question' %}">
                        <i class="fa-solid fa-plus"></i> Create Question
                    </a>
                {% endif %}
                {% if user.is_authenticated and user.userprofile.is_student %}
                    <a class="btn btn-warning disabled"
                       href="{% url 'polls:create-question' %}"
                       role="button"
                       aria-disabled="true">
                        <i class="fa-solid fa-plus"></i> Create Question
                    </a>
                {% endif %}
            </div>
        </div>
    </div>
{% endblock content %}

polls/templates/polls/results.html
{% extends "base_generic.html" %}
{% block title %}
    {{ question.question_text }}
{% endblock title %}
{% block content %}
    {% if user.is_authenticated %}
        <div class="d-flex justify-content-center">
            <div class="col-md-6">
                <ul>
                    {% for choice in question.choice_set.all %}
                        <li>{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes|pluralize }}</li>
                    {% endfor %}
                </ul>
                <br />
                <div class="row">
                    <a href="{% url 'polls:question-detail' question.id %}">Vote again?</a>
                </div>
            </div>
        </div>
    {% endif %}
{% endblock content %}